/*	matrices.h
|
|	Header for routines defined in matrices.c
|
|	Copyright (c) 1998 by David L. Swofford, Smithsonian Institution.
|	All rights reserved.
|
|	Things that (may) need to be done before including this file:
|	=============================================================
|	  -	if ANSI function prototypes are not supported, define NO_PROTOTYPES
|	  - typedef type VoidPtr as void * if possible, otherwise as char *
*/

typedef void * VoidPtr;

extern int          AllocMatrix (VoidPtr pA, size_t elSize, int rows, int cols);
extern void         DeallocMatrix (VoidPtr pA);
extern short **     ShortMatrix (int rows, int cols, short **a, short *buffer);
extern double **    DoubleMatrix (int rows, int cols, double **a, double *buffer);
extern void         SetIdentityMatrix (double **a, int n);
extern void         CopyDoubleMatrix (double **a, double **b, int m, int n);
extern void         ListDoubleMatrix (char *title, double **a, int m, int n);
extern void         ListFloatMatrix (char *title, float **a, int m, int n);
extern void         ListDoubleVector (char *title, double *a, int n);

extern double       **psdmatrix (int dim);
extern void         free_psdmatrix (double **m);
extern void         copy_psdmatrix (double **from, double **to, int dim);
extern int **       jimatrix (int a, int b);
extern void         free_jimatrix (int **m);
